# PBE

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.3491145.svg)](https://doi.org/10.5281/zenodo.3491145)

[![Build status](https://ci.appveyor.com/api/projects/status/qwb2ijro9m27acye?svg=true)](https://ci.appveyor.com/project/fmckenna/pbe)

### Performance Based Engineering Application ###

PBE is an open-source research application that can be used to assess the performance of a building in an earthquake scenario. The application focuses on quantifying building performance through decision variables. The user can characterize the structural model, the damage and loss model, and the seismic hazard model in this application. All models are interconnected by an uncertainty quantification framework that allows the user to define a flexible stochastic model for the problem. Given the stochastic model, the application first performs nonlinear response history simulations to get the Engineering Demand Parameters (EDPs) that describe structural response. Then, those EDPs are used to assess the Damage Measures (DMs) and Decision Variables (DVs) that characterize structural performance.

This tool is under active development. Researchers are encouraged to comment on what additional features and applications they would like to see in this application. If you want it, chances are many of your colleagues also would benefit from it. Additional requests should be posted at the [SimCenter forum](https://simcenter-messageboard.designsafe-ci.org/smf/index.php?board=7.0).


Please visit the [PBE Research Tool webpage](https://simcenter.designsafe-ci.org/research-tools/pbe-application/)
for more resources related to this tool. Additionally, this page
provides more information on the NHERI SimCenter, including other SimCenter
applications, FAQ, and how to collaborate.

### Documentation

Tool documentation can be found: https://nheri-simcenter.github.io/PBE-Documentation/

### Acknowledgement

This material is based upon work supported by the National Science Foundation under grants #1612843 and #2131111


### Contact

NHERI-SimCenter nheri-simcenter@berkeley.edu

